﻿// OpenTween - Client of Twitter
// Copyright (c) 2014 kim_upsilon (@kim_upsilon) <https://upsilo.net/~upsilon/>
// All rights reserved.
//
// This file is part of OpenTween.
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 3 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program. If not, see <http://www.gnu.org/licenses/>, or write to
// the Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
// Boston, MA 02110-1301, USA.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace OpenTween.Api
{
    [DataContract]
    public abstract class GeoJson
    {
        [DataMember(Name = "type")]
        public string Type { get; set; }
    }

    [DataContract]
    public class GeoJsonPoint : GeoJson
    {
        [DataMember(Name = "coordinates")]
        public double[] Coordinates { get; set; }

        public GeoJsonPoint()
        {
            this.Type = "Point";
        }
    }

    [DataContract]
    public class GeoJsonPolygon : GeoJson
    {
        [DataMember(Name = "coordinates")]
        public double[][][] Coordinates { get; set; }

        public GeoJsonPolygon()
        {
            this.Type = "Polygon";
        }
    }
}
